extends Node

var p1dead = false
var p2dead = false

var NUM_LIFES = 6
var p1lifes = NUM_LIFES
var p2lifes = NUM_LIFES

var ROUND_HITS = 3
var p1hits = ROUND_HITS
var p2hits = ROUND_HITS

var time = 0

var RESPAWN_TIME = 2

var p1respawntime = -10
var p2respawntime = -10

var p1respawn = false
var p2respawn = false

var last_loser = 0

var level = 1
# Defined in World.gd
# 1 regular
# 2 pit
# 3 slots
# 4 checkerboard
# 5 voidables
# 6 split
# 7 N
# 8 Icy
var MAX_LEVEL = 8 

func _ready():
	OS.set_window_fullscreen(true)
	Input.set_mouse_mode(Input.MOUSE_MODE_HIDDEN)
	set_process_input(true)
	set_fixed_process(true)
	
func _input(event):
	if(event.is_pressed()):
		if Input.is_action_pressed("custom_escape"):
			if get_node("/root/Credits") != null:
				get_tree().quit()
			elif get_node("/root/Menu") != null:
				get_tree().change_scene("res://NodeScenes/Credits.tscn")
			else:
				get_tree().change_scene("res://NodeScenes/Menu.tscn")
		elif Input.is_action_pressed("custom_fulscreen"):
			OS.set_window_fullscreen(!OS.is_window_fullscreen())

func _fixed_process(delta):
	time += delta
	if p1respawn && (time - p1respawntime) > RESPAWN_TIME:
		p1respawn = false
	if p2respawn && (time - p2respawntime) > RESPAWN_TIME:
		p2respawn = false

func kill_p1():
	if p1respawn:
		return
	print("Killing p1, hits ", p1hits, ", respawn ", p1respawn)
	p1hits -= 1
	get_node("/root/World/SamplePlayer").play("killfx", false)
	if p1hits > 0:
		p1respawn = true
		p1respawntime = time
	else:
		p1dead = true
		p1lifes -= 1
		last_loser = 1

func kill_p2():
	if p2respawn:
		return
	print("Killing p2, hits ", p2hits, ", respawn ", p2respawn)
	p2hits -= 1
	get_node("/root/World/SamplePlayer").play("killfx", false)
	if p2hits > 0:
		p2respawn = true
		p2respawntime = time
	else:
		p2dead = true
		p2lifes -= 1
		last_loser = 2
	
func get_num_lifes(n):
	if n == 1:
		return p1lifes
	elif n == 2:
		return p2lifes
	
func get_player_hits(n):
	if n == 1:
		return p1hits
	elif n == 2:
		return p2hits
	
func is_someone_dead():
	return p1dead || p2dead
	
func is_player_dead(n):
	if n == 1:
		return p1dead
	elif n == 2:
		return p2dead

func is_player_respawn(n):
	if n == 1:
		return p1respawn
	elif n == 2:
		return p2respawn
		
func did_player_lose_life(n):
	return last_loser == n
	
func next_round():
	p1dead = false
	p2dead = false
	p1respawn = false
	p2respawn = false
	p1hits = ROUND_HITS
	p2hits = ROUND_HITS
	next_level()
	get_tree().reload_current_scene()
	if p1lifes == 0 || p2lifes == 0:
		full_reset()
	
func soft_reset():
	p1lifes = NUM_LIFES
	p2lifes = NUM_LIFES
	p1dead = false
	p2dead = false
	p1respawn = false
	p2respawn = false
	p1hits = ROUND_HITS
	p2hits = ROUND_HITS
	last_loser = 0
	level = 1
	get_tree().reload_current_scene()
	
func full_reset():
	get_tree().change_scene("res://NodeScenes/Credits.tscn")
	
func get_level():
	return level
	
func next_level():
	level += 1
	if level > MAX_LEVEL:
		level = 1
		
func is_level_icy():
	return level == 8