extends Node2D

var num = 0

var showing_hearts = 0
var showing_extra_heart = false

var col = 0

var time = 0
var HEART_ANIM_TIME = 1
var HEART_ANIM_FREQ = 8

var hits = 3

var line_size = 1

func _ready():
	line_size = get_node("/root/Point3DManager").get_line_size()
	set_process(true)
	
func _process(delta):
	time += delta
	var mark_update = false
	if showing_extra_heart && time <= HEART_ANIM_TIME:
		mark_update = true
	var new_hits = get_node("/root/GameData").get_player_hits(num)
	if new_hits != hits:
		hits = new_hits
		mark_update = true
	if mark_update:
		update()
	
func set_player(n):
	num = n
	showing_hearts = get_node("/root/GameData").get_num_lifes(num)
	showing_extra_heart = get_node("/root/GameData").did_player_lose_life(num)
	if n == 1:
		col = get_node("/root/Point3DManager").get_grid_dimension().x
	elif n == 2:
		col = -1

func _draw():
	var man3d = get_node("/root/Point3DManager")
	
	var extra_heart = showing_extra_heart
	
	if time < HEART_ANIM_TIME:
		extra_heart = extra_heart && !(int((time - int(time)) * HEART_ANIM_FREQ) % 2)
		print ("Animate heart: ", showing_extra_heart, " in time ", time)
		print ("Animate heart: ", decimals(time))
	else:
		extra_heart = false

	var local_hearts = showing_hearts
	if extra_heart:
		local_hearts += 1
	
	for l in range(local_hearts):
		var x = col
		var y = l
		var localhits = 3
		if extra_heart && l == local_hearts - 1:
			localhits = 1
		if (!extra_heart && l == local_hearts - 1) || \
			(extra_heart && l == local_hearts - 2):
			localhits = max(hits, 1)
		var size = 0.3 * localhits
		var coordinates = [Vector2(0.5, 0.1),
			Vector2(0.1, 0.5),
			Vector2(0.1, 0.7),
			Vector2(0.3, 0.9),
			Vector2(0.5, 0.7),
			Vector2(0.7, 0.9),
			Vector2(0.9, 0.7),
			Vector2(0.9, 0.5)]
		var points = []
		for c in coordinates:
			points.push_back(Vector2( \
				x - (c.x - 0.5) * size, y - (c.y - 0.5) * size))
	
		var projectedpoints = []
		for pi in range(points.size()):
			var toproject = Vector3(points[pi].x, points[pi].y, 0)
			projectedpoints.push_back(man3d.project_point(toproject))
			
		var color = Color(1, 0, 1)
		for j in range(points.size()):
			var p1 = j
			var p2 = j + 1
			if j == (points.size() - 1):
				p2 = 0
			draw_line(projectedpoints[p1], projectedpoints[p2], color, line_size)

