extends Node

var NUM_TILES_X = 1
var NUM_TILES_Y = 1

var void_tiles = []

func _ready():
	var gs = get_node("/root/Point3DManager").get_grid_dimension()
	NUM_TILES_X = gs.x
	NUM_TILES_Y = gs.y
	initialize_tiles()
	initialize_players()
	initialize_life_counters()
	pass

func initialize_tiles():
	var level = get_node("/root/GameData").get_level()
	var tileDic = get_node("/root/World/Tiles")
	var tileScene = load("res://NodeScenes/Tile.tscn")
	var size = get_viewport().get_rect().size
	for i in range(NUM_TILES_X):
		for j in range(NUM_TILES_Y):
			var tile = tileScene.instance()
			tileDic.add_child(tile)
			tile.x = i
			tile.y = j
			var thirdx = int(NUM_TILES_X / 3)
			var thinx = int(NUM_TILES_X / 5)
			var thirdy = int(NUM_TILES_Y / 3)
			var thiny = int(NUM_TILES_Y / 5)
			var void = false
			if (level == 2 && 
				i >= thirdx && i <= NUM_TILES_X - 1 - thirdx &&
				j >= thirdy && j <= NUM_TILES_Y - 1 -  thirdy):
				void = true
			elif (level == 3 &&
				(i >= thinx && i <= NUM_TILES_X - 1 - thinx) &&
				(j >= thiny && j <= NUM_TILES_Y - 1 -  thiny) &&
				(j < 2 * thiny || j > NUM_TILES_Y - 1 -  2 * thiny)):
				void = true
			elif (level == 4 && 
				(((i < thirdx || i > NUM_TILES_X - 1 - thirdx) &&
				(i != 0 && i != NUM_TILES_X - 1) &&
				(j >= thirdy && j <= NUM_TILES_Y - 1 - thirdy)) ||
				((i >= thirdx && i <= NUM_TILES_X - 1 - thirdx) &&
				(j < thirdy || j > NUM_TILES_Y - 1 - thirdy)))):
				void = true
			elif level == 5:
				tile.set_voidable(true)
			elif (level == 6 && 
				(i > thirdx && i < NUM_TILES_X - 1 - thirdx)):
				void = true
			elif (level == 7 && 
				(i > thinx && i < NUM_TILES_X - 1 - thinx) &&
				((i + j < (NUM_TILES_X + NUM_TILES_Y) / 2 - thinx ) || 
				(i + j > (NUM_TILES_X + NUM_TILES_Y) / 2 + thinx ))):
				void = true
				
			if void:
				void_tiles.push_back(Vector2(i, j))
				tile.set_void(true)
			
func initialize_players():
	var playerScene = load("res://NodeScenes/Player.tscn")
	var world = get_node("/root/World")
	var size = get_viewport().get_rect().size
	var player1 = playerScene.instance()
	world.add_child(player1)
	player1.num = 1
	var player2 = playerScene.instance()
	world.add_child(player2)
	player2.num = 2
	
func initialize_life_counters():
	var counterScene = load("res://NodeScenes/LifeCounter.tscn")
	var world = get_node("/root/World")
	var counter1 = counterScene.instance()
	world.add_child(counter1)
	counter1.set_player(1)
	var counter2 = counterScene.instance()
	world.add_child(counter2)
	counter2.set_player(2)
	
var p1pos = Vector3()
var p2pos = Vector3()

var last_jumped_p1 = Vector2(-1, -1)
var last_jumped_p2 = Vector2(-1, -1)

func set_p1pos(vec):
	vec.x = round(vec.x)
	vec.y = round(vec.y)
	p1pos = vec
	
func set_p2pos(vec):
	vec.x = round(vec.x)
	vec.y = round(vec.y)
	p2pos = vec
	
func get_p1pos():
	return p1pos
	
func get_p2pos():
	return p2pos
	
func set_p_jumped(player, vec):
	vec.x = round(vec.x)
	vec.y = round(vec.y)
	if player == 1:
		last_jumped_p1 = vec
	elif player == 2:
		last_jumped_p2 = vec
		
func get_p_jumped(player):
	if player == 1:
		return last_jumped_p1
	elif player == 2:
		return last_jumped_p2
	
func notify_new_void_tile(vec):
	void_tiles.push_back(vec)
	
func not_void(vec):
	vec.x = round(vec.x)
	vec.y = round(vec.y)
	for v in void_tiles:
		if v == vec:
			return false
	return true