extends Node

var camPos = Vector3()

var SIZE_MULTIPLIER = 1

var TILE_SIZE = 16 * SIZE_MULTIPLIER

var NUM_TILES_X = (640 * SIZE_MULTIPLIER / TILE_SIZE) - 2
var NUM_TILES_Y = 320 * SIZE_MULTIPLIER / TILE_SIZE

var DIAG = 0

var origin = Vector2()
var size = Vector2()

func _ready():
	DIAG = Vector2(NUM_TILES_X, NUM_TILES_Y).length()
	
	origin = get_viewport().get_rect().size
	origin.x = (origin.x / NUM_TILES_X) * 1.5
	origin.y = (origin.y / NUM_TILES_Y) * 0.5
	size = get_viewport().get_rect().size
	size.width = (size.width / (NUM_TILES_X + 2)) * (NUM_TILES_X - 1)
	size.height = (size.height / NUM_TILES_Y) * (NUM_TILES_Y - 1)
	
	camPos.x = NUM_TILES_X / 2
	camPos.y = NUM_TILES_Y / 2
	camPos.z = 5
	
	pass

func get_scale(vec3):
	var scale = (camPos.z - vec3.z) / camPos.z
	if scale <= 0:
		return 20
	else:
		return 1 / scale

func project_point(vec3):
	var x = origin.x + size.x * vec3.x / (NUM_TILES_X - 1)
	var y = origin.y + size.y * vec3.y / (NUM_TILES_Y - 1)
	return Vector2(x, y)
	
func get_grid_dimension():
	return Vector2(NUM_TILES_X, NUM_TILES_Y)
	
func get_tile_size():
	return TILE_SIZE
	
func get_diag():
	return DIAG
	
func get_line_size():
	return 2