extends Node

var waves = []

var time = 0
var WAVE_SPEED = 10

func _ready():
	set_fixed_process(true)
	
func _fixed_process(delta):
	var gd = get_node("/root/GameData")
	if gd.is_someone_dead():
		return
	
	time += delta
	var alivewaves = []
	var diag = get_node("/root/Point3DManager").get_diag()
	for wave in waves:
		var diff = time - wave.btime
		wave.curfront = diff * wave.speed + 1
		if wave.curfront <= diag:
			alivewaves.push_back(wave)
	waves = alivewaves
		
func get_waves():
	return waves
	
func get_time():
	return time

func add_wave(x, y, player_num):
	waves.push_back({x = x, 
		y = y, 
		btime = time, 
		speed = WAVE_SPEED, 
		size = 1, 
		curfront = 0,
		source_player = player_num})

func remove_all_waves():
	waves = []
	time = 0